/* Se da un sir numeric a[1]....a[n]
    Pentru fiecare valoare a[i] din sir, sa se gaseasca
    cea mai apropiata valoare a[j] (j > i) astfel incat
    a[i] < a[j]
*/
#include <fstream>
#include <vector>
#include <stack>
#include <algorithm>
using namespace std;

ifstream fin("stiva.in");
ofstream fout("stiva.out");

vector<int> a, p;
stack<int> st;
int n;

int main()
{
    fin >> n;
    a = vector<int>(n + 1);
    p = vector<int>(n + 1);
    for (int i = 1; i <= n; ++i)
        fin >> a[i];

    /// Complexitate: O(n)
    for (int i = 1; i <= n; ++i)
    {
       while (!st.empty() && a[st.top()] < a[i])
       {
           p[st.top()] = i;
           st.pop();
       }

       st.push(i);
    }

    for (int i = 1; i <= n; ++i)
        fout << a[i] << ' ';
    fout << '\n';

    for (int i = 1; i <= n; ++i)
        fout << p[i] << ' ';

    return 0;
}


